include:
  - local: /ci/workflow-rules.yaml
  - local: /ci/default-image.yaml

stages:
  - build
  - deploy

ci-image:
  stage: build
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  image: docker:20.10
  services:
    - docker:20.10-dind
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker pull ${CI_REGISTRY_IMAGE}:latest || true
  script:
    - docker build .
      --cache-from ${CI_REGISTRY_IMAGE}:latest
      --tag ${CI_REGISTRY_IMAGE}:${CI_PIPELINE_ID}
      --tag ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:${CI_PIPELINE_ID}
  after_script:
    - docker logout ${CI_REGISTRY}
  rules:
    - if: $CHART_NAME
      when: never
    - if: $FORCE_UPDATE
      when: never
    - changes:
        - scripts/*.sh
        - .dockerignore
        - Dockerfile
      when: on_success
    - when: never

pages:
  stage: deploy
  before_script:
    - if [ -n "${FORCE_UPDATE:-}" ]; then
        rm -f public/index.yaml;
      fi
  script:
    - helm repo index public --url https://kube-ops.gitlab.io/helm/repository
  artifacts:
    paths:
      - public
  rules:
    - if: $CHART_NAME
      when: never
    - changes:
        - public/*
      when: on_success
    - if: $FORCE_UPDATE
      when: always
    - when: never

upload-new-file:
  stage: deploy
  script:
    - upload-chart
  rules:
    - if: $CHART_NAME
      when: on_success
    - when: never
